/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  SILT, main module                                                      *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 ***************************************************************************/

#define SILT
#define NOVARS

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <io.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "prog.h"
#include "max.h"
#include "silt.h"
#include "opusprm.h"

#define AREA_BUF_SIZE   6144
char *area_buf=NULL;

struct m_pointers prm;
struct _menu menu;

char last,
     do_prm,
     do_areas,
     do_sysbbs,
     do_sysdat,
     do_menus,
     do_sort,
     do_network,
     do_unattended,
     done_sys,
     done_equip,
     done_matrix,
     done_session;

char strings[HEAP_SIZE],
     ctl_name[120],
     ver_14[120]="",
     ver_16[120]="",
     line[MAX_LINE],
     *ctl_delim=" \t\n",
     *cantfind_file_ctl="\n\aError!  Can't find file `%s', line %d of CTL file!\n",
     *cc_section="Compiling Section: %s",
     *cc_area=   "Compiling Area:    %s",
     *cc_menu=   "Compiling Menu:    %s";

int menuopt,
    offset=1,
    linenum,             /* Line number of BBS.CTL file! */
    protocol_num=0,
    priv_word,
    bytes_saved=0;

struct _aidx aidx[1296];
int n_aidx=0;

FILE *areasfile;

int num_class=0;

#ifndef __TURBOC__
#undef EmbedCopyright
#define EmbedCopyright()
#endif

extern char *area_buf;

/* for qsort */
static int stcomp(struct _st *arg1,struct _st *arg2)
{
  return(strcmp(arg1->token,arg2->token));
}


main(int argc,char *argv[])
{
  struct pointers_14 prm14;
  struct pointers_16 prm16;

  int prmfile;

  char temp[PATHLEN],
       *p;

  int areasidx,
      x;

  do_prm=do_areas=do_sysbbs=do_sysdat=do_menus=do_unattended=do_network=FALSE;
  done_sys=done_equip=done_matrix=done_session=FALSE;
  areasfile=NULL;

  last=LAST_none;
  strings[0]='\0';

  Hello("SILT","The Maximus-CBCS Control File Compiler",VERSION,"1990");

  if (argc < 2)
    Fmt();

  for (x=2;x < argc;x++)
  {
    if (*argv[x]=='-' || *argv[x]=='/')
    {
      p=argv[x]+1;

      while (*p)
      {
        switch(tolower(*p))
        {
          case 'p':
            do_prm=TRUE;
            break;

          case 'a':
            do_areas=TRUE;
            break;

          case 's':
            if (strnicmp(p+1,"103",3)==0)
              do_sysbbs=TRUE;
            else if (strnicmp(p+1,"110",3)==0)
              do_sysdat=TRUE;
            else Fmt();

            p += 3;
            break;

          case 'm':
            do_menus=TRUE;
            break;

          case 'n':
            do_network=TRUE;
            break;

          case 'o':
            do_sort=TRUE;
            break;

          case 'u':
            do_unattended=TRUE;
            break;

          case 'x':
            do_prm=do_areas=do_sysbbs=do_sysdat=do_menus=TRUE;
            break;

          default:
           printf("\aInvalid command-line parameter:  `%s'!\n",argv[x]);
           Fmt();
        }

        p++;
      }
    }
    else
    {
      printf("\aInvalid command-line parameter:  `%s'!\n",argv[x]);
      Fmt();
    }
  }

  /* If no args specified, do everything except for SYSBBS/SYSDAT! */

  if (!do_prm && !do_areas && !do_menus && !do_sysbbs && !do_sysdat)
    do_prm=do_areas=do_menus=TRUE;

  if (do_sysbbs || do_sysdat)
    do_areas=TRUE;

  printf("Processing: ");

  if (do_prm)
  {
    printf("PRM file");

    if (do_areas || do_menus || do_sysbbs || do_sysdat)
      printf(", ");
  }

  if (do_sysbbs)
  {
    printf("SYSTEM??.BBS");

    if (do_areas || do_menus || do_sysdat)
      printf(", ");
  }

  if (do_sysdat)
  {
    printf("SYSTEM??.DAT");

    if (do_areas || do_menus)
      printf(", ");
  }

  if (do_areas)
  {
    printf("Msg/File Areas");

    if (do_sort)
      printf(" (sorted)");

    if (do_menus)
      printf(", ");
  }

  if (do_menus)
    printf("Menus");

  putchar('\n');

  if (do_sort && !do_areas)
    printf("Warning!  You must specify `-a' to use the `-o' sort option!\n");

  sprintf(temp,"%s.Ctl",argv[1]);

  Initialize_Prm();
  qsort(silt_table, silt_table_size, sizeof(silt_table[0]), stcomp);

  Parse_Ctlfile(temp);

  if (do_areas)
  {
    if (areasfile)
    {
      fclose(areasfile);

      if (area_buf)
        free(area_buf);
    }

    /* Now sort and write the index file... */

    if ((areasidx=open(strings+prm.aidx_name,O_CREAT | O_TRUNC | O_WRONLY | O_BINARY,S_IREAD | S_IWRITE))==-1)
    {
      printf("\n\aError opening `%s' for write!\n",strings+prm.aidx_name);
      exit(1);
    }

    if (do_sort)
      qsort(aidx,n_aidx,sizeof(struct _aidx),Aidx_Cmp);

    write(areasidx,(char *)aidx,sizeof(struct _aidx)*n_aidx);
    close(areasidx);
  }

  if (do_prm || *ver_14 || *ver_16)
    putchar('\n');

  if (do_prm)
  {
    if (! prm.achg_keys)
      Make_String(prm.achg_keys,"[]?");
    
    printf("\nWriting Maximus Version %d PRM file...",CTL_VER);

    if (done_sys && done_equip && done_session)
    {
      sprintf(temp,"%s.Prm",argv[1]);

      if ((prmfile=open(temp,O_CREAT | O_TRUNC | O_WRONLY | O_BINARY,
                        S_IREAD | S_IWRITE))==-1)
      {
        printf("\n\aError opening `%s' for write!\n",temp);
        exit(1);
      }

      write(prmfile,(char *)&prm,sizeof(struct m_pointers));
      write(prmfile,strings,offset);
      close(prmfile);
    }
    else printf("\n\aWarning!  PRM creation specified, but all sections are not present!");
  }

  if (do_prm && *ver_14)
  {
    printf("\nWriting Opus Version 14 PRM file...");

    if ((prmfile=open(ver_14,O_CREAT | O_TRUNC | O_WRONLY | O_BINARY,
                      S_IREAD | S_IWRITE))==-1)
    {
      printf("\n\aError opening `%s' for write!\n",ver_14);
      exit(1);
    }

    memset(&prm14,'\0',sizeof(struct pointers_14));

    prm14.version=14;
    prm14.testmode=(byte)(prm.flags & FLAG_keyboard);
    prm14.total_callers=0L;
    prm14.quote_position=0L;
    prm14.multitasker=prm.multitasker;
    prm14.snooping=(byte)(prm.flags & FLAG_snoop);
    prm14.edit_exit=prm.edit_exit;
    prm14.verbose=(byte)(prm.log_mode==LOG_verbose ? TRUE : FALSE);
    prm14.terse=(byte)(prm.log_mode==LOG_terse ? TRUE : FALSE);
    prm14.trace=(byte)(prm.log_mode==LOG_trace ? TRUE : FALSE);
    prm14.show_areapath=FALSE;
    prm14.task_num=prm.task_num;
    prm14.exit_val=prm.exit_val;
    prm14.val_outside=0;
    prm14.val_zero=0;
    prm14.no_crashmail=0;
    prm14.auto_kill=prm.auto_kill;
    prm14.crashexit=0;
    prm14.unpack_arc=0;
    prm14.toss_echo=0;
    prm14.arc_exit=0;
    prm14.old_dtr=0;
    prm14.carrier_mask=prm.carrier_mask;
    prm14.handshake_mask=prm.handshake_mask;
    prm14.ctla_priv=prm.ctla_priv;
    prm14.max_baud=prm.max_baud;
    prm14.min_baud=prm.min_baud;
    prm14.speed_graphics=prm.speed_graphics;
    prm14.com_port=prm.com_port;
    prm14.logon_priv=prm.logon_priv;
    prm14.date_style=prm.date_style;
    prm14.seenby_priv=prm.seenby_priv;

    for (x=0;x < 16;x++)
    {
      prm14.msg_ask[x]=prm.msg_ask[x];
      prm14.msg_assume[x]=prm.msg_assume[x];
    }

    prm14.msg_fromfile=prm.msg_fromfile;
    prm14.watchdog=(byte)(prm.flags & FLAG_watchdog);
    prm14.video=prm.video;
    prm14.logon_time=prm.logon_time;
    prm14.echo_exit=0;
    prm14.Flags=(byte)(prm.flags & FLAG_log_echo ? LOGECHO : 0);

    prm14.our_zone=prm.address[0].Zone;
    prm14.matrix_mask=0;

    for (x=0;x < MAXCLASS;x++)
      memmove(&prm14.class[x],&prm.class[x],sizeof(struct class_rec));

    for (x=0;x < ALIAS_CNT;x++)
    {
      prm14.alias[x].net=prm.address[x].Net;
      prm14.alias[x].node=prm.address[x].Node;
    }

    prm14.m_init=0;
    prm14.predial=0;
    prm14.postdial=0;
    prm14.timeformat=prm.timeformat;
    prm14.dateformat=prm.dateformat;
    prm14.fkey_path=prm.misc_path;
    prm14.parm_outside=0;
    prm14.parm_zero=0;
    prm14.sys_path=prm.sys_path;
    prm14.user_file=prm.user_file;
    prm14.net_info=prm.net_info;
    prm14.sched_name=0;
    prm14.logo=prm.logo;
    prm14.welcome=prm.welcome;
    prm14.bulletin=0;
    prm14.editorial=0;
    prm14.quote=prm.quote;
    prm14.question=0;
    prm14.request_list=0;
    prm14.newuser1=prm.newuser1;
    prm14.newuser2=prm.newuser2;
    prm14.rookie=prm.rookie;
    prm14.application=prm.application;
    prm14.avail_list=0;
    prm14.hlp_editor=prm.hlp_editor;
    prm14.hlp_replace=prm.hlp_replace;
    prm14.msg_inquire=prm.msg_inquire;
    prm14.hlp_locate=prm.hlp_locate;
    prm14.hlp_contents=prm.hlp_contents;
    prm14.out_leaving=prm.out_leaving;
    prm14.out_return=prm.out_return;
    prm14.daylimit=prm.daylimit;
    prm14.timewarn=prm.timewarn;
    prm14.sysop=prm.sysop;
    prm14.tooslow=prm.tooslow;
    prm14.xferbaud=prm.xferbaud;
    prm14.msgarea_list=prm.msgarea_list;
    prm14.file_area_list=prm.file_area_list;
    prm14.maillist_file=0;
    prm14.byebye=prm.byebye;

    for (x=0;x < MAX_EXTERN;x++)
      prm14.protocols[x]=prm.protocols[x];

    prm14.local_editor=prm.local_editor;

    prm14.file_mgt=0;
    prm14.hold_area=prm.junk;
    prm14.barricade=prm.barricade;
    prm14.badaccess=0;
    prm14.msg_mgt=0;
    prm14.mailpath=0;
    prm14.filepath=0;
    prm14.oped_help=prm.oped_help;
    prm14.temppath=prm.temppath;
    prm14.m_busy=prm.m_busy;
    prm14.system_name=prm.system_name;
    prm14.freq_about=0;
    prm14.log_name=prm.log_name;

    write(prmfile,(char *)&prm14,sizeof(struct pointers_14));
    write(prmfile,strings,offset);

    close(prmfile);
  }

  if (do_prm && *ver_16)
  {
    printf("\nWriting Opus Version 17 PRM file...");

    if ((prmfile=open(ver_16,O_CREAT | O_TRUNC | O_WRONLY | O_BINARY,
                      S_IREAD | S_IWRITE))==-1)
    {
      printf("\n\aError opening `%s' for write!\n",ver_14);
      exit(1);
    }

    memset(&prm16,'\0',sizeof(struct pointers_16));

    prm16.version=17;
    prm16.task_num=prm.task_num;

    for (x=0;x < ALIAS_CNT;x++)
      prm16.alias[x]=prm.address[x];

    prm16.video=prm.video;
    prm16.testmode=(byte)(prm.flags & FLAG_keyboard ? TRUE : FALSE);
    prm16.carrier_mask=prm.carrier_mask;
    prm16.handshake_mask=prm.handshake_mask;
    prm16.max_baud=prm.max_baud;
    prm16.com_port=prm.com_port;
    prm16.multitasker=prm.multitasker;
    prm16.mailer_type=1;
    prm16.ModemFlag=0;
    prm16.LogFlag=1;
    prm16.StyleFlag=0;
    prm16.FWDflag=0;
    prm16.Flags=0;
    prm16.Flags2=0;
    prm16.edit_exit=prm.edit_exit;
    prm16.exit_val=prm.exit_val;
    prm16.crashexit=0;
    prm16.arc_exit=0;
    prm16.echo_exit=0;
    prm16.UDB_Flags=0;
    prm16.min_baud=prm.min_baud;
    prm16.color_baud=prm.speed_graphics;
    prm16.date_style=prm.date_style;
    prm16.logon_priv=MaxPrivToOpus(prm.logon_priv);
    prm16.seenby_priv=MaxPrivToOpus(prm.seenby_priv);
    prm16.ctla_priv=MaxPrivToOpus(prm.ctla_priv);
    prm16.FromFilePriv=MaxPrivToOpus(prm.msg_fromfile);

    for (x=0;x < 16;x++)
    {
      prm16.AskPrivs[x]=MaxPrivToOpus(prm.msg_ask[x]);
      prm16.AssumePrivs[x]=MaxPrivToOpus(prm.msg_assume[x]);
    }

    prm16.logon_time=prm.logon_time;
    prm16.matrix_mask=0;
    prm16.MinNetBaud=prm.min_baud;
    prm16.MaxJanusBaud=19200u;

    for (x=0;x < MAXCLASS;x++)
    {
      memmove(&prm16.class[x],&prm.class[x],sizeof(struct class_rec));
      prm16.class[x].ClassPriv=MaxPrivToOpus(prm.class[x].priv);
    }

    for (x=0;x < 10;x++)
    {
      prm16.FosRegs[x].ax=0;
      prm16.FosRegs[x].bx=0;
      prm16.FosRegs[x].cx=0;
      prm16.FosRegs[x].dx=0;
    }

    prm16.F_Reward=prm.ul_reward;

    prm16.last_area=0xff;
    prm16.last_farea=0xff;

    prm16.MDM_Init=0;
    prm16.MDM_PreDial=0;
    prm16.MDM_PostDial=0;
    prm16.MDM_LookBusy=prm.m_busy;
    prm16.misc_path=prm.misc_path;
    prm16.sys_path=prm.sys_path;
    prm16.temppath=prm.temppath;
    prm16.net_info=prm.net_info;
    prm16.mailpath=0;
    prm16.filepath=0;
    prm16.hold_area=prm.junk;
    prm16.user_file=prm.user_file;
    prm16.sched_name=0;
    prm16.langdir=0;
    prm16.spcldir=0;
    prm16.system_name=prm.system_name;
    prm16.sysop=prm.sysop;
    prm16.timeformat=prm.timeformat;
    prm16.dateformat=prm.dateformat;

    for (x=0;x < MAX_EXTERN;x++)
      prm16.protocols[x]=prm.protocols[x];

    prm16.logo=prm.logo;
    prm16.welcome=prm.welcome;
    prm16.newuser1=prm.newuser1;
    prm16.newuser2=prm.newuser2;
    prm16.rookie=prm.rookie;
    prm16.HLP_Editor=prm.hlp_editor;
    prm16.HLP_Replace=prm.hlp_replace;
    prm16.HLP_Inquire=prm.msg_inquire;
    prm16.HLP_Locate=prm.hlp_locate;
    prm16.HLP_Contents=prm.hlp_contents;
    prm16.HLP_OPed=prm.oped_help;
    prm16.OUT_Leaving=prm.out_leaving;
    prm16.OUT_Return=prm.out_return;
    prm16.ERR_DayLimit=prm.daylimit;
    prm16.ERR_TimeWarn=prm.timewarn;
    prm16.ERR_TooSlow=prm.tooslow;
    prm16.ERR_XferBaud=prm.xferbaud;
    prm16.LIST_MsgAreas=prm.msgarea_list;
    prm16.LIST_FileAreas=prm.file_area_list;
    prm16.FREQ_MyFiles=0;
    prm16.FREQ_OKList=0;
    prm16.FREQ_About=0;
    prm16.OEC_Quotes=prm.quote;
    prm16.byebye=prm.byebye;
    prm16.local_editor=prm.local_editor;
    prm16.barricade=prm.barricade;
/*  prm16.Files_BBS=prm.files_override; */
    prm16.mailer=0;
    prm16.common=0;
    prm16.log_name=prm.log_name;

    write(prmfile,(char *)&prm16,sizeof(struct pointers_16));
    write(prmfile,strings,offset);
    close(prmfile);
  }

  if (do_prm && bytes_saved)
    printf("\n(Optimized %d bytes.)",bytes_saved);

  printf("\n\nDone!\n");

  return 0;
}







Parse_Session(FILE *ctlfile)
{
  int x,y;

  static int num_yell;

  long tl;

  char temp[MAX_LINE],  /* Contains entire line */
       temp2[MAX_LINE], /* First word on line */
       p[MAX_LINE],     /* First word on line */
       *sp,
       *s2;

  linenum++;

  while (1)
  {
    if (fgets(line,MAX_LINE,ctlfile) != NULL)
    {
      Strip_Comment(line);

      if (*line)
      {
        strcpy(temp,line);

        getword(line,p,ctl_delim,1);

        if (isnl(p))
          ;
        else if (eqstri(p,"end"))
          break;
        else if (eqstri(p,"min"))
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"logon"))
          {
            getword(line,p,ctl_delim,4);
            prm.min_baud=atoi(p);
          }
          else if (eqstri(p,"nontty"))
          {
            getword(line,p,ctl_delim,4);
            prm.speed_graphics=atoi(p);
          }
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"logon"))
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"level"))
          {
            getword(line,p,ctl_delim,3);
            prm.logon_priv=Deduce_Priv(p);
          }
          else if (eqstri(p,"preregistered"))
            prm.logon_priv=PREREGISTERED;
          else if (eqstri(p,"timelimit"))
          {
            getword(line,p,ctl_delim,3);
            prm.logon_time=atoi(p);
          }
          else Unknown_Ctl(linenum,p);
        }
        else if ((x=1,eqstri(p,"uses")) || (x=2,eqstri(p,"file")))
        {
          getword(line,p,ctl_delim,2);

          if (x==2 && eqstri(p,"date"))
          {
            getword(line,p,ctl_delim,3);

            if ((x=1,eqstri(p,"automatic")) ||
                (x=2,(eqstri(p,"none") || eqstri(p,"manual"))))
            {
              if (x==1)
                prm.flags |= FLAG_autodate;
              else prm.flags &= ~FLAG_autodate;

              getword(line,p,ctl_delim,4);

              if (! *p)
              {
                if (x==1)
                  prm.date_style=0;
                else prm.date_style=-1;
              }
              else if (eqstri(p,"mm-dd-yy"))
                prm.date_style=0;
              else if (eqstri(p,"dd-mm-yy"))
                prm.date_style=1;
              else if (eqstri(p,"yy-mm-dd"))
                prm.date_style=2;
              else if (eqstri(p,"yymmdd"))
                prm.date_style=3;
              else Unknown_Ctl(linenum,p);
            }
            else if (eqstri(p,"yymmdd")   || eqstri(p,"mm/dd/yy") ||
                     eqstri(p,"mm-dd-yy") || eqstri(p,"dd") ||
                     eqstri(p,"none"))
              ;
            else Unknown_Ctl(linenum,p);
          }
          else
          {
            s2=fchar(line,ctl_delim,3);

            Add_Filename(s2);

            if (eqstri(p,"logo"))
              Make_Filename(prm.logo,s2)
            else if (eqstri(p,"application"))
              Make_Filename(prm.application,s2)
            else if (eqstri(p,"welcome"))
            {
              Make_Filename(prm.welcome,s2)

              if (! prm.rookie)
                prm.rookie=prm.welcome;

              if (! prm.newuser2)
                prm.newuser2=prm.welcome;
            }
            else if (eqstri(p,"newuser1"))
              Make_Filename(prm.newuser1,s2)
            else if (eqstri(p,"newuser2"))
              Make_Filename(prm.newuser2,s2)
            else if (eqstri(p,"rookie"))
              Make_Filename(prm.rookie,s2)
            else if (eqstri(p,"quote"))
              Make_Filename(prm.quote,s2)
            else if (eqstri(p,"daylimit"))
              Make_Filename(prm.daylimit,s2)
            else if (eqstri(p,"timewarn"))
              Make_Filename(prm.timewarn,s2)
            else if (eqstri(p,"tooslow"))
              Make_Filename(prm.tooslow,s2)
            else if (eqstri(p,"locatehelp"))
              Make_Filename(prm.hlp_locate,s2)
            else if (eqstri(p,"contentshelp"))
              Make_Filename(prm.hlp_contents,s2)
            else if (eqstri(p,"xferbaud"))
              Make_Filename(prm.xferbaud,s2)
            else if (eqstri(p,"fileareas"))
              Make_Filename(prm.file_area_list,s2)
            else if (eqstri(p,"msgareas"))
              Make_Filename(prm.msgarea_list,s2)
            else if (eqstri(p,"opedhelp") || eqstri(p,"magnethelp") || eqstri(p,"maxedhelp"))
              Make_Filename(prm.oped_help,s2)
            else if (eqstri(p,"lorehelp") || eqstri(p,"boredhelp"))
              Make_Filename(prm.hlp_editor,s2)
            else if (eqstri(p,"replacehelp"))
              Make_Filename(prm.hlp_replace,s2)
            else if (eqstri(p,"inquirehelp"))
              Make_Filename(prm.msg_inquire,s2)
            else if (eqstri(p,"leaving"))
              Make_Filename(prm.out_leaving,s2)
            else if (eqstri(p,"returning"))
              Make_Filename(prm.out_return,s2)
            else if (eqstri(p,"byebye"))
              Make_Filename(prm.byebye,s2)
            else if (eqstri(p,"barricade"))
              Make_Filename(prm.barricade,s2)
            else if (eqstri(p,"badlogon"))
              Make_Filename(prm.bad_logon,s2)
            else if (eqstri(p,"nospace"))
              Make_Filename(prm.no_space,s2)
            else if (eqstri(p,"beginchat"))
              Make_Filename(prm.chat_begin,s2)
            else if (eqstri(p,"endchat"))
              Make_Filename(prm.chat_end,s2)
            else if (eqstri(p,"shell_leaving"))
              Make_Filename(prm.shelltodos,s2)
            else if (eqstri(p,"shell_returning"))
              Make_Filename(prm.backfromdos,s2)
            else if (eqstri(p,"nomail"))
              Make_Filename(prm.nomail,s2)
            else if (eqstri(p,"notfound"))
              Make_Filename(prm.notfound,s2)
            else if (eqstri(p,"cant_enter_area"))
              Make_Filename(prm.areanotexist,s2)
            else if (eqstri(p,"filename_format"))
              Make_Filename(prm.fname_format,s2)
            else if (eqstri(p,"scanhelp"))
              Make_Filename(prm.hlp_scan,s2)
            else if (eqstri(p,"protocoldump"))
              Make_Filename(prm.proto_dump,s2)
            else if (eqstri(p,"listhelp"))
              Make_Filename(prm.hlp_list,s2)
            else Unknown_Ctl(linenum,p);

            if (x==1 && do_prm)           /* USES statement */
              if (! fexist(s2))
              {
                strcat(s2,".BBS");

                if (! fexist(s2))
                {
                  *strrchr(temp,'.')='\0';
                  printf(cantfind_file_ctl,s2,linenum);
                  Compiling(-1,NULL,NULL);
                }
              }
          }
        }
        else if (eqstri(p,"kill"))
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"private"))
          {
            getword(line,p,ctl_delim,3);

            if (eqstri(p,"never"))
              prm.auto_kill=0;
            else if (eqstri(p,"ask"))
              prm.auto_kill=1;
            else if (eqstri(p,"always"))
              prm.auto_kill=2;
            else Unknown_Ctl(linenum,p);
          }
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"after"))
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"call"))
          {
            getword(line,p,ctl_delim,4);
            prm.exit_val=(byte)atoi(p);
          }
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"edit"))
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"disable"))
          {
            getword(line,p,ctl_delim,3);

            if (eqstri(p,"userlist"))
              prm.flags |= FLAG_no_ulist;
            else if (eqstri(p,"magnet") || eqstri(p,"maxed"))
              prm.flags |= FLAG_no_magnet;
            else Unknown_Ctl(linenum,p);
          }
          else if (eqstri(p,"menu"))
          {
            getword(line,p,ctl_delim,3);
            Make_String(prm.edit_menu,p);
          }
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"format"))
        {
          getword(line,p,ctl_delim,2);
          s2=fchar(line,ctl_delim,3);

          if (eqstri(p,"time"))
            Make_String(prm.timeformat,s2)
          else if (eqstri(p,"date"))
            Make_String(prm.dateformat,s2)
          else if (eqstri(p,"msgheader"))
            Make_String(prm.msg_header,s2)
          else if (eqstri(p,"msgformat"))
            Make_String(prm.msg_format,s2)
          else if (eqstri(p,"msgfooter"))
            Make_String(prm.msg_footer,s2)
          else if (eqstri(p,"fileheader"))
            Make_String(prm.file_header,s2)
          else if (eqstri(p,"fileformat"))
            Make_String(prm.file_format,s2)
          else if (eqstri(p,"filefooter"))
            Make_String(prm.file_footer,s2)
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"define"))
        {
          getword(line,p,ctl_delim,2);

          y=Deduce_Class(Deduce_Priv(p));

          getword(line,p,ctl_delim,3);
          getword(line,temp2,ctl_delim,4);

          if (eqstri(p,"cume"))
            prm.class[y].max_time=atoi(temp2);
          else if (eqstri(p,"time"))
            prm.class[y].max_call=atoi(temp2);
          else if (eqstri(p,"logon"))
          {
            getword(line,p,ctl_delim,5);
            prm.class[y].min_baud=atoi(p);
          }
          else if (eqstri(p,"file"))
          {
            getword(line,p,ctl_delim,5);

            if (eqstri(temp2,"limit"))
            {
              tl=atol(p);

              if (tl > 32767L)
              {
                tl=32767L;

                printf("\n\aError on line %d of CTL file!  Max File Limit is 32767.\n",linenum);
                Compiling(-1,NULL,NULL);
              }

              prm.class[y].max_dl=(int)tl;
            }
            else if (eqstri(temp2,"baud"))
              prm.class[y].min_file_baud=atoi(p);
            else if (eqstri(temp2,"ratio"))
              prm.class[y].ratio=atoi(p);
            else Unknown_Ctl(linenum,p);
          }
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"ratio"))
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"threshold"))
          {
            getword(line,p,ctl_delim,3);
            prm.ratio_threshold=atoi(p);
          }
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"upload"))
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"reward"))
          {
            getword(line,p,ctl_delim,3);

            if (isnl(p) || p[strlen(p)-1] != '%')
            {
              printf("\n\aError!  The `Upload Reward' value must have a trailing percentage sign!\n");
              exit(1);
            }
            else prm.ul_reward=atoi(p);
          }
          else if (eqstri(p,"log"))
          {
            s2=fchar(line,ctl_delim,3);
            Make_Filename(prm.ul_log,s2);
          }
          else if (eqstri(p,".bbs"))
          {
            getword(line,p,ctl_delim,4);
            prm.ulbbs_priv=Deduce_Priv(p);
          }
          else if (eqstri(p,"space"))
          {
            getword(line,p,ctl_delim,3);

            if (eqstri(p,"free"))
            {
              getword(line,p,ctl_delim,4);
              prm.k_free=atol(p);
            }
            else Unknown_Ctl(linenum,p);
          }
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"mailchecker"))
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"kill"))
          {
            getword(line,p,ctl_delim,3);
            prm.mc_kill_priv=Deduce_Priv(p);
          }
          else if (eqstri(p,"reply"))
          {
            getword(line,p,ctl_delim,3);
            prm.mc_reply_priv=Deduce_Priv(p);
          }
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"local"))
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"editor"))
          {
            s2=fchar(line,ctl_delim,3);
            Make_String(prm.local_editor,s2);
          }
          else if (eqstri(p,"input"))
            prm.flags2 |= FLAG2_ltimeout;
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"userlist"))
        {
          getword(line,p,ctl_delim,2);
          s2=fchar(line,ctl_delim,3);

          if (eqstri(p,"minimum"))
            prm.min_ulist=Deduce_Priv(s2);
          else if (eqstri(p,"maximum"))
            prm.max_ulist=Deduce_Priv(s2);
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"no"))
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"realname"))
            prm.flags |= FLAG_norname;
          else if (eqstri(p,"hogging"))   /* Just ignore, always active */
            ;
          else if (eqstri(p,"filesbbs"))
          {
            getword(line,p,ctl_delim,3);

            if (eqstri(p,"download"))
            {
              getword(line,p,ctl_delim,4);
              prm.dlall_priv=Deduce_Priv(p);
            }
            else Unknown_Ctl(linenum,p);
          }
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"ask"))
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"phone"))
            prm.flags |= FLAG_ask_phone;
          else if (eqstri(p,"real"))
            prm.flags |= FLAG_ask_name;
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"alias"))
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"system"))
            prm.flags |= FLAG_alias;
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"chat"))
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"external"))
            Make_Filename(prm.chat_prog,fchar(line,ctl_delim,3))
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"external"))
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"protocol") || eqstri(p,"batchprotocol") ||
              eqstri(p,"batchexitprotocol") || eqstri(p,"exitprotocol"))
          {
            getword(line,p,ctl_delim,3);

            if (eqstri(p,"errorlevel"))
            {
              getword(line,p,ctl_delim,4);
              prm.protoexit=atoi(p);
            }
            else
            {
              if (protocol_num==MAX_EXTERNP)
              {
                printf("\n\aError!  Too many external protocols, line %d.\n",linenum);
                exit(1);
              }

              getword(line,p,ctl_delim,2);

              if (eqstri(p,"batchprotocol"))
                prm.protoflag[protocol_num] |= XTERNBATCH;
              else if (eqstri(p,"batchexitprotocol"))
                prm.protoflag[protocol_num] |= (XTERNBATCH | XTERNEXIT);
              else if (eqstri(p,"exitprotocol"))
                prm.protoflag[protocol_num] |= XTERNEXIT;

              getword(line,p,ctl_delim,3);
              s2=fchar(line,ctl_delim,4);

              Make_Filename(prm.protocols[protocol_num],p);

              if (s2 && *s2)
                Make_String(prm.protoname[protocol_num],s2)
              else prm.protoname[protocol_num]=prm.protocols[protocol_num];

              protocol_num++;
            }
          }
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"highest"))
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"msgarea"))
          {
            getword(line,p,ctl_delim,3);
            prm.high_msgarea=Set_Area_Name(p);
          }
          else if (eqstri(p,"filearea"))
          {
            getword(line,p,ctl_delim,3);
            prm.high_filearea=Set_Area_Name(p);
          }
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"area"))
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"data"))
          {
            getword(line,p,ctl_delim,3);
            Make_Filename(prm.adat_name,p);
          }
          else if (eqstri(p,"index"))
          {
            getword(line,p,ctl_delim,3);
            Make_Filename(prm.aidx_name,p);
          }
          else if (eqstri(p,"change"))
          {
            getword(line,p,ctl_delim,4);
            Make_String(prm.achg_keys,strupr(p));
          }
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"yell"))
        {
          getword(line,temp,ctl_delim,2);

          if (eqstri(temp,"off"))
            prm.noise_ok=FALSE;
          else
          {
            prm.yell[num_yell].weekday=(byte)Parse_Weekday(temp);

            getword(line,temp,ctl_delim,3);

            if (4 != sscanf(temp,"%d:%d-%d:%d",&prm.yell[num_yell].start_hour,
                                               &prm.yell[num_yell].start_min,
                                               &prm.yell[num_yell].end_hour,
                                               &prm.yell[num_yell].end_min))
            {
              printf("\n\aInvalid yell format: `%s' on line %d of CTL file.\n",temp,
                     linenum);

              Compiling(-1,NULL,NULL);
            }
            else
            {
              getword(line,temp,ctl_delim,4);
              prm.yell[num_yell++].bells=(byte)atoi(temp);
            }
          }
        }
        else if (eqstri(p,"menu"))
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"path"))
          {
            s2=fchar(line,ctl_delim,3);
            Make_Path(prm.menupath,s2);

            if (! direxist(strings+prm.menupath))
              makedir(strings+prm.menupath);
          }
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"first"))
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"menu"))
          {
            getword(line,p,ctl_delim,3);
            Make_String(prm.first_menu,p);
          }
          else if (eqstri(p,"file"))
          {
            getword(line,p,ctl_delim,4);
            prm.begin_filearea=Set_Area_Name(p);
          }
          else if (eqstri(p,"message"))
          {
            getword(line,p,ctl_delim,4);
            prm.begin_msgarea=Set_Area_Name(p);
          }
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"compatible"))
          prm.flags |= FLAG_lbaud96;
        else if (eqstri(p,"statusline"))
          prm.flags |= FLAG_statusline;
        else if (eqstri(p,"save"))
        {
          getword(line,p,ctl_delim,2);

          if (eqstri(p,"directories"))
          {
            getword(line,p,ctl_delim,3);

            for (sp=p;*sp;sp++)
            {
              if ((*sp=toupper(*sp)) >= 'A' && *sp <= 'Z')
                BitOn(prm.drives_to_save,*sp-'A');
              else
              {
                printf("\n\aInvalid drive `%c' specified on line %d of CTL file!\n",*p,linenum);
                Compiling(-1,NULL,NULL);
              }
            }
          }
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"arrow"))
          prm.flags2 |= FLAG2_msgread;
        else if (eqstri(p,"app") || eqstri(p,"application"))
          ;
        else Unknown_Ctl(linenum,p);
      }

      linenum++;
    }
    else break;
  }

  linenum++;

  return 0;
}



Parse_Area(FILE *ctlfile,char *name)
{
  int sysbbs,
      clnum,
      x,y;

  int write_origin,
      num_movr=0,
      num_fovr=0;

  struct _area area;
  struct _sys    sys103;
  struct _sys110 sys110;

  char temp[MAX_LINE],  /* Contains entire line */
       p[MAX_LINE],     /* First word on line */
       add_idx,
       *lin,
       *sp;


  unsigned char *s,
                *s2;

  linenum++;

  if (do_areas)
  {
    if (*(strings+prm.adat_name))
    {
      if (areasfile==NULL)
      {
        if ((areasfile=fopen(strings+prm.adat_name,"w+b"))==NULL)
        {
          printf("\n\awError opening `%s' for write!\n",strings+prm.adat_name);
          exit(1);
        }

        if ((area_buf=malloc(AREA_BUF_SIZE))==NULL)
          printf("Warning!  Not enough memory to allocate buffer for AREA.DAT.\n");
        else setvbuf(areasfile,area_buf,_IOFBF,AREA_BUF_SIZE);
      }
    }
    else
    {
      printf("\a\n\nError!  All area statements must come AFTER the `Area Data' and\n");
      printf("`Area Index' keywords!\n");
      exit(1);
    }
  }

  if (!done_sys || !done_equip || !done_matrix || !done_session)
  {
    printf("\n\n\aError!  All area statements must come AFTER the System, Equipment,\n");
    printf("Matrix, and Session sections!\n");
    exit(1);
  }

  if (isnl(name) || (name[0] && !isalnum(name[0])) ||
      (name[1] && !isalnum(name[1])))
  {
    printf("\n\aInvalid area statement in line %d of CTL file!\n",linenum);
    exit(1);
  }

  if (strlen(name)==2 && name[0]=='0')  /* No beginning zeros... */
  {
    name[0]=name[1];
    name[1]='\0';
  }

  y=Set_Area_Name(name);
  Blank_Area(&area);

  memset(&sys103,'\0',sizeof(struct _sys));
  Blank_Sys(&sys103,0);

  memset(&sys110,'\0',sizeof(struct _sys110));


  if (do_areas || do_sysbbs || do_sysdat)
  {
    for (x=0;x < n_aidx;x++)
      if (aidx[x].area==y)
      {
        fseek(areasfile,aidx[x].offset,SEEK_SET);
        fread((char *)&area,sizeof(struct _area),1,areasfile);
        fseek(areasfile,aidx[x].offset,SEEK_SET);
          
        add_idx=FALSE;
        break;
      }
        
      if (x==n_aidx)
        add_idx=TRUE;
  }

  while (1)
  {
    if (fgets(line,MAX_LINE,ctlfile) != NULL)
    {
      Strip_Comment(line);

      if (*line)
      {
        strcpy(temp,line);

        lin=line;
        clnum=-1;

TryAgain:

        getword(lin,p,ctl_delim,1);

        if (isnl(p))
          ;
        else if (eqstri(p,"end"))
          break;
        else if (!(do_areas || do_sysbbs || do_sysdat))
          ;
        else if (eqstri(p,"access"))
        {
          getword(lin,p,ctl_delim,2);
          area.msgpriv=area.filepriv=Deduce_Priv(p);
          area.msglock=area.filelock=Deduce_Lock(p);
        }
        else if (eqstri(p,"msgaccess"))
        {
          getword(lin,p,ctl_delim,2);
          area.msgpriv=Deduce_Priv(p);
          area.msglock=Deduce_Lock(p);
        }
        else if (eqstri(p,"fileaccess"))
        {
          getword(lin,p,ctl_delim,2);
          area.filepriv=Deduce_Priv(p);
          area.filelock=Deduce_Lock(p);
        }
        else if (eqstri(p,"fileinfo"))
          strnncpy(area.fileinfo,fchar(lin,ctl_delim,2),79);
        else if (eqstri(p,"download"))
        {
          sp=fchar(lin,ctl_delim,2);

          if (do_areas || do_sysbbs || do_sysdat)
            Add_Path(sp,0);

          strnncpy(area.filepath,sp,79);
        }
        else if (eqstri(p,"menupath"))
          ;
        else if (eqstri(p,"filemenuname"))
          strnncpy(area.filemenuname,fchar(lin,ctl_delim,2),79);
        else if (eqstri(p,"msgmenuname"))
          strnncpy(area.msgmenuname,fchar(lin,ctl_delim,2),79);
        else if (eqstri(p,"filelist"))
        {
          sp=fchar(lin,ctl_delim,2);

          if (do_areas || do_sysbbs || do_sysdat)
            Add_Filename(sp);

          strnncpy(area.filesbbs,sp,79);
        }
        else if (eqstri(p,"upload"))
        {
          sp=fchar(lin,ctl_delim,2);

          if (do_areas || do_sysbbs || do_sysdat)
            Add_Path(sp,0);

          strnncpy(area.uppath,sp,79);
        }
        else if (eqstri(p,"msginfo"))
          strnncpy(area.msginfo,fchar(lin,ctl_delim,2),79);
        else if (eqstri(p,"origin"))
        {
          s=fchar(lin,ctl_delim,2);

          area.origin_aka=atoi(s);

          if (area.origin_aka >= ALIAS_CNT || !isdigit(*s))
          {
            printf("\n\aInvalid matrix address number on line %d of control file.  Valid addresses\n"
                   "are from 0 through 14.  See docs for details on `Origin' statement.\n",
                    linenum);

            Compiling(-1,NULL,NULL);
            area.origin_aka=0;
          }

          if (*(s2=fchar(lin,ctl_delim,3)) != '\0')
            strnncpy(area.origin,s2,61);
        }
        else if (eqstri(p,"msgname"))
          strnncpy(area.msgname,fchar(lin,ctl_delim,2),39);
        else if (eqstri(p,"barricade"))
        {
          sp=fchar(lin,ctl_delim,2);

          if (do_areas || do_sysbbs || do_sysdat)
            Add_Filename(sp);

          strnncpy(area.msgbar,sp,79);
          strnncpy(area.filebar,sp,79);
        }
        else if (eqstri(p,"msgbarricade"))
        {
          sp=fchar(lin,ctl_delim,2);

          if (do_areas || do_sysbbs || do_sysdat)
            Add_Filename(sp);

          strnncpy(area.msgbar,sp,79);
        }
        else if (eqstri(p,"filebarricade"))
        {
          sp=fchar(lin,ctl_delim,2);

          if (do_areas || do_sysbbs || do_sysdat)
            Add_Filename(sp);

          strnncpy(area.filebar,sp,79);
        }
        else if (eqstri(p,"local"))
        {
          sp=fchar(lin,ctl_delim,2);

          if (do_areas || do_sysbbs || do_sysdat)
            Add_Path(sp,0);

          strnncpy(area.msgpath,sp,79);

          /* Turn off MATRIX and ECHO bits */
          Attrib_And(clnum,~(SYSMAIL | ECHOMAIL),&area);
        }
        else if (eqstri(p,"echomail"))
        {
          sp=fchar(lin,ctl_delim,2);

          if (do_areas || do_sysbbs || do_sysdat)
            Add_Path(sp,0);

          strnncpy(area.msgpath,sp,79);

          /* Turn off MATRIX bit and set echomail */
          Attrib_Or(clnum,ECHOMAIL,&area);
          Attrib_And(clnum,~SYSMAIL,&area);
        }
        else if (eqstri(p,"matrix"))
        {
          sp=fchar(lin,ctl_delim,2);

          if (do_areas || do_sysbbs || do_sysdat)
            Add_Path(sp,0);

          strnncpy(area.msgpath,sp,79);

          /* Set MATRIX bit and turn off echomail */
          Attrib_Or(clnum,SYSMAIL,&area);
          Attrib_And(clnum,~ECHOMAIL,&area);
        }
        else if (eqstri(p,"public"))
        {
          getword(lin,p,ctl_delim,2);

          if (eqstri(p,"only"))         /* Public only */
          {
            Attrib_Or(clnum,NOPRIVATE,&area);
            Attrib_And(clnum,~NOPUBLIC,&area);
          }
          else if (eqstri(p,"and")) /* Private/Public */
            Attrib_And(clnum,~(NOPUBLIC | NOPRIVATE),&area);
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"private"))
        {
          getword(lin,p,ctl_delim,2);

          if (eqstri(p,"only"))         /* Private only */
          {
            Attrib_Or(clnum,NOPUBLIC,&area);
            Attrib_And(clnum,~NOPRIVATE,&area);
          }
          else if (eqstri(p,"and")) /* Private/Public */
            Attrib_And(clnum,~(NOPUBLIC | NOPRIVATE),&area);
          else Unknown_Ctl(linenum,p);
        }
        else if (eqstri(p,"read-only") || eqstri(p,"read"))
          Attrib_Or(clnum,NOPUBLIC | NOPRIVATE,&area);
        else if (eqstri(p,"anonymous"))
          Attrib_Or(clnum,ANON_OK,&area);
        else if (eqstri(p,"high"))
          Attrib_Or(clnum,HIGHBIT,&area);
        else if (eqstri(p,"no"))
          Attrib_Or(clnum,NREALNAME,&area);
        else if (eqstri(p,"use"))
          Attrib_Or(clnum,UREALNAME,&area);
        else if (eqstri(p,"msgoverride"))
        {
          if (num_movr >= MAX_OVR)
          {
            printf("\n\aError on line %d of .CTL file!  Too many message override\n"
                   "privs specified!\n",linenum);

            Compiling(-1,NULL,NULL);
          }
          else
          {
            getword(lin,p,ctl_delim,2);
            area.movr[num_movr].ch=toupper(*p);

            getword(lin,p,ctl_delim,3);
            area.movr[num_movr].priv=Deduce_Priv(p);
            area.movr[num_movr++].lock=Deduce_Lock(p);
          }
        }
        else if (eqstri(p,"fileoverride"))
        {
          if (num_fovr >= MAX_OVR)
          {
            printf("\n\aError on line %d of .CTL file!  Too many file override\n"
                   "privs specified!\n",linenum);

            Compiling(-1,NULL,NULL);
          }

          getword(lin,p,ctl_delim,2);
          area.fovr[num_fovr].ch=toupper(*p);

          getword(lin,p,ctl_delim,3);
          area.fovr[num_fovr].priv=Deduce_Priv(p);
          area.fovr[num_fovr++].lock=Deduce_Lock(p);
        }
        else if (eqstri(p,"twit") ||
                 eqstri(p,"disgrace") ||
                 eqstri(p,"limited") ||
                 eqstri(p,"normal") ||
                 eqstri(p,"worthy") ||
                 eqstri(p,"privil") ||
                 eqstri(p,"privel") ||
                 eqstri(p,"favored") ||
                 eqstri(p,"extra") ||
                 eqstri(p,"clerk") ||
                 eqstri(p,"asstsysop") ||
                 eqstri(p,"sysop"))
        {
          x=Deduce_Priv(p);

          for (y=0;y < num_class;y++)
            if (prm.class[y].priv==x)
            {
              clnum=y;
              break;
            }

          if (y==num_class)
          {
            printf("\a\nError!  Can't find priv class for `%s' on line %d of CTL file!\n",p,linenum);
            exit(1);
          }

          lin=fchar(line,ctl_delim,2);
          goto TryAgain;
        }
        else if (eqstri(p,"app") || eqstri(p,"application"))
          ;
        else Unknown_Ctl(linenum,p);
      }

      linenum++;
    }
    else break;
  }

  linenum++;

  if (do_areas || do_sysbbs || do_sysdat)
  {
    Remove_Backslash(fancy_str(area.msgpath));
    Remove_Backslash(fancy_str(area.filepath));
    Remove_Backslash(fancy_str(area.uppath));

    if (!isnl(area.msgpath) && !direxist(area.msgpath) &&
        makedir(area.msgpath)==-1)
    {
      printf("\n\aCan't create directory `%s'!\n",area.msgpath);
      Compiling(-1,NULL,NULL);
    }

    if (!isnl(area.filepath) && !direxist(area.filepath) &&
        makedir(area.filepath)==-1)
    {
      printf("\n\aCan't create directory `%s'!\n",area.filepath);
      Compiling(-1,NULL,NULL);
    }

    if (!isnl(area.uppath) && !direxist(area.uppath) &&
        makedir(area.uppath)==-1)
    {
      printf("\n\aCan't create directory `%s'!\n",area.uppath);
      Compiling(-1,NULL,NULL);
    }

    area.areano=Set_Area_Name(name);

    if ((s=strchr(name,'/')) != NULL)
      strcpy(area.name,s+1);
    else strcpy(area.name,name);

    fancy_str(area.msgmenuname);
    fancy_str(area.filemenuname);

    Add_Backslash(area.msgpath);
    Add_Backslash(area.filepath);
    Add_Backslash(area.uppath);

    write_origin=FALSE;

    if (do_sysbbs)
    {
      strnncpy(sys103.msgpath,area.msgpath,39);

      if (*area.msgbar || *area.filebar)
        strnncpy(sys103.bbspath,*area.msgbar ? area.msgbar : area.filebar,39);
      else strnncpy(sys103.bbspath,strings+prm.sys_path,39);

      strcpy(sys103.hlppath,strings+prm.sys_path);
      strcat(sys103.hlppath,"Hlp\\");

      strnncpy(sys103.uppath,area.uppath,39);
      strnncpy(sys103.filepath,area.filepath,39);
      sys103.attrib=area.attrib[0];

      if (area.msgpriv != HIDDEN)
      {
        sys103.priv=area.msgpriv;
        sys103.lock=area.msglock;
      }
      else
      {
        sys103.priv=area.filepriv;
        sys103.lock=area.filelock;
      }

      if (eqstr(name,"0"))
        sprintf(temp,"%sSYSTEM.BBS",strings+prm.sys_path);
      else sprintf(temp,"%sSYSTEM%s.BBS",strings+prm.sys_path,name);

      if ((sysbbs=open(temp,O_CREAT | O_TRUNC | O_WRONLY | O_BINARY,S_IREAD | S_IWRITE))==-1)
      {
        printf("\n\aCan't open `%s' for write!\n",temp);
        exit(1);
      }

      write(sysbbs,(char *)&sys103,sizeof(struct _sys));
      close(sysbbs);




      if (! isnl(area.msginfo))
      {
        if (isnl(area.msgpath))
        {
          printf("\n\aError!  No message path specified for area %s!\n",name);
          Compiling(-1,NULL,NULL);
        }
        else
        {
          sprintf(temp,"%sDIR.BBS",area.msgpath);

          if ((sysbbs=open(temp,O_CREAT | O_TRUNC | O_WRONLY | O_TEXT,S_IREAD | S_IWRITE))==-1)
          {
            printf("\a\nError opening `%s' for write!\n",temp);
            Compiling(-1,NULL,NULL);
          }
          else
          {
            lprintf(sysbbs,"%s\n",area.msginfo);
            close(sysbbs);
          }
        }
      }

      if (! isnl(area.fileinfo))
      {
        if (isnl(area.filepath))
        {
          printf("\n\aError!  No files path specified for area %s!\n",name);
          Compiling(-1,NULL,NULL);
        }
        else
        {
          sprintf(temp,"%sDIR.BBS",area.filepath);

          sysbbs=open(temp,O_CREAT | O_TRUNC | O_WRONLY | O_TEXT,S_IREAD | S_IWRITE);

          if (sysbbs==-1)
          {
            printf("\a\nError opening `%s' for write!\n",temp);
            Compiling(-1,NULL,NULL);
          }
          else
          {
            lprintf(sysbbs,"%s\n",area.fileinfo);
            close(sysbbs);
          }
        }
      }

      write_origin=TRUE;
    }

    if (do_sysdat)
    {
      write_origin=TRUE;

      sys110.version=110;
      sys110.menu=0;
      sys110.attrib=area.attrib[0];

      if (*area.msgbar)
        strcpy(sys110.barrpath,area.msgbar);
      else if (*area.filebar)
        strcpy(sys110.barrpath,area.filebar);

      strcpy(sys110.filtitle,area.fileinfo);
      strcpy(sys110.filepath,area.filepath);
      strcpy(sys110.uppath,area.uppath);
      strcpy(sys110.listpath,area.filesbbs);
      sys110.FilePriv=MaxPrivToOpus(area.filepriv);
      sys110.FileLock=area.filelock;

      strcpy(sys110.msgtitle,area.msginfo);
      strcpy(sys110.msgpath,area.msgpath);
      sys110.MsgPriv=MaxPrivToOpus(area.msgpriv);
      sys110.MsgLock=area.msglock;
      strcpy(sys110.EchoName,area.msgname);
      strcpy(sys110.listpath,area.filesbbs);


      if (strlen(name) != 2)
      {
        name[1]=name[0];
        name[0]='0';
        name[2]='\0';
      }

      if (isdigit(name[0]) && isdigit(name[1]))
      {
        x=atoi(name);
        sprintf(temp,"%sSYSTEM%02x.DAT",strings+prm.sys_path,x);

        if ((sysbbs=open(temp,O_CREAT | O_TRUNC | O_WRONLY | O_BINARY,S_IREAD | S_IWRITE))==-1)
        {
          printf("\n\aCan't open `%s' for write!\n",temp);
          exit(1);
        }

        write(sysbbs,(char *)&sys110,sizeof(struct _sys110));
        close(sysbbs);
      }
    }

    if (write_origin)
    {
      if (area.origin_aka != -1 && !eqstri(area.origin,strings+prm.system_name))
      {
        if (area.origin_aka)
          sprintf(temp,"%sORIGIN.%03x",area.msgpath,area.origin_aka);
        else sprintf(temp,"%sORIGIN.",area.msgpath);

        if ((sysbbs=open(temp,O_CREAT | O_TRUNC | O_WRONLY | O_TEXT,S_IREAD | S_IWRITE))==-1)
        {
          printf("\n\aError opening `%s' for write!\n",temp);
          Compiling(-1,NULL,NULL);
        }
        else
        {
          lprintf(sysbbs,"%s\n",area.origin);
          close(sysbbs);
        }
      }
    }

    if (do_areas)
    {
      /* Now write the areas file, for easier access! */

      if (area.origin_aka==-1)
        area.origin_aka=0;

      x=FALSE;
      
      for (s=s2=area.origin;*s;s++)
      {
        if (*s < ' ' || (!(area.attrib[0] & HIGHBIT) && *s >= '\x7f'))
        {
          if (x==FALSE)
          {
            printf("\nBad char: %s\n          ",area.origin);
            x=TRUE;
          }

          for (y=0;y < (s-s2);y++)
            printf(" ");

          printf("^");

          s2=s+1;
        }
      }

      if (x)
      {
        printf("\n");
        Compiling(-1,NULL,NULL);
      }

      if (add_idx)
      {
        aidx[n_aidx].name_crc=0L;
        aidx[n_aidx].area=area.areano;
        aidx[n_aidx++].offset=ftell(areasfile);
      }

      fwrite((char *)&area,sizeof(struct _area),1,areasfile);
      fseek(areasfile,0L,SEEK_END);
    }
  }

  return 0;
}


